About
Google's Nano Banana pro (Gemini 3.0 Pro Image) is a cutting-edge text-to-image model enabling high-res 4K image generation optimized for phones. Ready-to-use REST inference API, best performance, no coldstarts, affordable pricing.
1. Calling the API
Setup your API Key
To begin using Infron, you first need to create an account and generate your API Key.
Once you have your API key, set it as an environment variable in your runtime environment. This allows your applications to securely access Infron’s API.
export INFRON_KEY="YOUR_API_KEY"
Submit a request
For long-running requests, you can poll for results.
curl https://media.onerouter.pro/v1/images/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "google/nano-banana-pro/text-to-image",
"prompt": "An action shot of a black lab swimming in an inground suburban swimming pool. The camera is placed meticulously on the water line, dividing the image in half, revealing both the dogs head above water holding a tennis ball in it's mouth, and it's paws paddling underwater.",
"n": 1,
"aspect_ratio": "16:9",
"resolution": "1K",
"output_format": "png",
"response_format": "url",
"seed": 1,
"enable_web_search": true
}
EOF
Response with queue task id
The response will look like this:
{
"code": 200,
"message": "success",
"data": {
"task_id": "2a7603f261b4414380cb1a6a607d7357",
"object": "image",
"model": "google/nano-banana-pro/text-to-image",
"status": "created",
"urls": {
"query": "https://media.onerouter.pro/v1/images/tasks/2a7603f261b4414380cb1a6a607d7357"
},
"created_at": "2026-06-04 06:37:42.94"
}
}
Fetch request status
You can fetch the status of a request to check if it is completed or still in progress.
curl https://media.onerouter.pro/v1/images/tasks/{task_id} \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
# For example
curl https://media.onerouter.pro/v1/images/tasks/2a7603f261b4414380cb1a6a607d7357 \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json"
Response with queue task status query
{
"code": 200,
"message": "success",
"data": {
"task_id": "2a7603f261b4414380cb1a6a607d7357",
"object": "image",
"model": "google/nano-banana-pro/text-to-image",
"status": "in_progress",
"fail_reason": "",
"submit_time": 1780555063,
"start_time": 1780555062,
"finish_time": 0,
"outputs": [],
"created_at": "2026-06-04 06:37:43"
}
}
Possible statuses:
- created
- in_progress
- processing
- completed
- failed
created -> in_progress → processing → completed | failed
Poll every 1-2 seconds until status is "completed" or "failed"
Get the result (when status is "completed")
Once the request is completed, you can fetch the result. See the Output Schema for the expected result format.
{
"code": 200,
"message": "success",
"data": {
"task_id": "2a7603f261b4414380cb1a6a607d7357",
"object": "image",
"model": "google/nano-banana-pro/text-to-image",
"status": "completed",
"fail_reason": "",
"submit_time": 1780555063,
"start_time": 1780555062,
"finish_time": 1780555110,
"outputs": [
"https://storage.googleapis.com/infron_gcs/image%2Fgemini_f0882eff-b63b-4229-a4b1-cc80714ada48.png"
],
"usage": {
"completion_tokens": 1441,
"image_count": 1,
"prompt_tokens": 57,
"resolution": "1K",
"total_tokens": 1498,
"web_search": true
},
"cost": {
"total_cost": 0.138366,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0.138366,
"video_cost": 0,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-06-04 06:37:43"
}
}
2. Schema
Input
| Parameter | Type | Required | Default | Range | Description |
|---|---|---|---|---|---|
| model | string | Yes | -- | Explore all models | Model name. |
| prompt | string | Yes | -- | -- | Text prompt for generation; Positive text prompt. |
| n | integer | No | 1 | ==1 | Number of images to generate. |
| aspect_ratio | string | No | -- | 1:1, 2:3, 3:2, 3:4, 4:3, 4:5, 5:4, 9:16, 16:9, 21:9 | Aspect ratio of the generated image. |
| resolution | string | No | 1K | 1K, 2K, 4K | Resolution of the generated image. |
| output_format | string | No | png | png, jpeg, webp | Output format for the images. |
| response_format | string | No | url | url, b64_json | URL or JSON string. |
| seed | integer | No | -- | >=1 | The random seed to use for the generation. |
| enablewebsearch | boolean | No | False | true, false | Enable web search. |
Example request
curl https://media.onerouter.pro/v1/images/generations \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d @- <<'EOF'
{
"model": "google/nano-banana-pro/text-to-image",
"prompt": "An action shot of a black lab swimming in an inground suburban swimming pool. The camera is placed meticulously on the water line, dividing the image in half, revealing both the dogs head above water holding a tennis ball in it's mouth, and it's paws paddling underwater.",
"n": 1,
"aspect_ratio": "16:9",
"resolution": "1K",
"output_format": "png",
"response_format": "url",
"seed": 1,
"enable_web_search": true
}
EOF
Output
| Parameter | Type | Range | Description |
|---|---|---|---|
| code | integer | -- | Status code of the request. |
| message | string | -- | Status message of the request. |
| data | object | -- | Data of the task. |
| data.task_id | string | -- | ID of the task. |
| data.object | string | -- | Object type of the task. |
| data.model | string | -- | Model name of the task. |
| data.status | string | created, in_progress, processing, completed, failed | Status of the task. |
| data.fail_reason | string | -- | Fail reason of the task. |
| data.submit_time | integer | -- | Timestamp of the task submission. |
| data.start_time | integer | -- | Timestamp of the task start. |
| data.finish_time | integer | -- | Timestamp of the task finish. |
| data.outputs | array | -- | Outputs of the task. |
| data.created_at | string | -- | Timestamp of the task creation. |
Example output
{
"code": 200,
"message": "success",
"data": {
"task_id": "2a7603f261b4414380cb1a6a607d7357",
"object": "image",
"model": "google/nano-banana-pro/text-to-image",
"status": "completed",
"fail_reason": "",
"submit_time": 1780555063,
"start_time": 1780555062,
"finish_time": 1780555110,
"outputs": [
"https://storage.googleapis.com/infron_gcs/image%2Fgemini_f0882eff-b63b-4229-a4b1-cc80714ada48.png"
],
"usage": {
"completion_tokens": 1441,
"image_count": 1,
"prompt_tokens": 57,
"resolution": "1K",
"total_tokens": 1498,
"web_search": true
},
"cost": {
"total_cost": 0.138366,
"cost_details": {
"prompt_cost": 0,
"completion_cost": 0,
"image_cost": 0.138366,
"video_cost": 0,
"audio_cost": 0,
"native_web_search_cost": 0,
"plugin_web_search_cost": 0,
"tools_cost": 0,
"prompt_cache_read_cost": 0,
"prompt_cache_write_cost": 0,
"prompt_cache_write_5_min": 0,
"prompt_cache_write_1_h": 0,
"reasoning_cost": 0,
"discount_rate": 1,
"is_byok": false,
"byok_cost": 0
}
},
"created_at": "2026-06-04 06:37:43"
}
}
3. Detailed Pricing
| Pricing Type | Unit | Price |
|---|---|---|
| Input text | 1M tokens | $2.00 |
| Input image | 1M tokens | $2.00 |
| Input image | 1 image | ~$0.0011 |
| Output text / thinking | 1M tokens | $12.00 |
| Output image | 1M tokens | $120.00 |
| Resolution | Estimated Output Tokens | Estimated Price |
|---|---|---|
| 1K / 1024×1024 | 1,120 tokens | $0.134 |
| 2K / 2048×2048 | 1,120 tokens | $0.134 |
| 4K / 4096×4096 | 2,000 tokens | $0.240 |